require_relative 'project'
# require_relative 'dieroll'
require_relative 'fundinground'
require_relative 'pledge'


module Top
  class FundRequest

    attr_reader :category, :fully_funded, :under_funded

    def initialize(category)
      @category = category
      @container = []
    end
  
    def add_project_to_category(project)
      @container <<  project
    end
  
    #--------------------------------------------
    # two ways of loading projects from csv file.
    #--------------------------------------------
    #--------------------------------------------
    # first way
    #--------------------------------------------
 
    # def load_users_projects(from_file) 
    #     CSV.foreach(from_file) do |row|
    #     project = Project.new(row[0], row[1].to_i, row[2].to_i)
    #     add_project_to_category(project)
    #   end
    # end
  
    #--------------------------------------------
    # second way - first half. Second half in project.rb
    #--------------------------------------------
  
    def load_users_projects(from_file)
      File.readlines(from_file).each do |line|
        add_project_to_category(Project.from_csv(line))
      end
    end
      
    #--------------------------------------------  
    #--------------------------------------------
  
    def funding_round(round)
      puts "Project category: #{@category}"
      
        @container.each do |project|
          puts project
        end
    
      PledgePool::lists_pledge_options
    
      1.upto(round) do |round|
        puts "\nRound: #{round} of funding:"
      
        @container.each do |project|
          FundingRound.funding_round(project)
      
        # B  
          project.each_received_pledge do |pledge|
            puts "$#{pledge.amount} in #{pledge.name} pledges"
          end
        
          puts "#{project.funding} GRAND TOTAL amount\n\n"
        
          puts project
        end
      end
      print_summary
    end
  
    def print_project_data(project)
     "achieved #{project.funding} funding out of #{project.goal} goal"
    end
  
    def fully_funded
      @container.select{|project| project.fully_funded?}
    end
    
    def under_funded
      @container.reject{|project| project.fully_funded?}
    end
  
    def print_summary
      puts "\nFully funded projects:"
      fully_funded.each do |project|
      fully_funded = "Project: #{project.name}".ljust(25, '.')
        puts "#{fully_funded} #{print_project_data(project)}"
      end
    
      puts "\nUnderfunded projects:"
      under_funded.each do |project|
        under_funded = "Project: #{project.name}".ljust(25, '.')
          puts "#{under_funded} #{print_project_data(project)}"
      end
    end
  
    def save_summary_to_text_file(to_file="save.txt")
      File.open(to_file, "w") do |file|
        file.puts "Projects that still need funding (underfunded):"
        under_funded.each do |project|
          file.puts "Project #{project.name} - #{print_project_data(project)}"
        end
      end
    end
  end
end


if __FILE__ == $0
  project4 = Project.new("aaa", 500, 1000)
  project5 = Project.new("bbb", 750, 1500)
  category3 = FundRequest.new("Self-study")
  category3.add_project_to_category(project4)
  category3.add_project_to_category(project5)


  category3.funding_round(3)
  
  category3.save_summary_to_text_file
end