# require_relative 'fundrequest'
require_relative 'pledge'
require 'csv'
require_relative 'fundable'

module Top
  class Project
    include Fundable
  
    attr_accessor :name
    attr_accessor :funding 
    attr_reader :goal
  
    def initialize(name, funding=0, goal)
      @name = name
      @funding = funding
      @goal = goal
      @pledges = Hash.new(0)
    end
  
    def to_s
      "Project #{@name} has $#{@funding} in funding towards a goal of $#{@goal}. So the remaining gap is #{gap}."
    end

  

    def collecting_pledges(sample_pledge)
      @pledges[sample_pledge.name] += sample_pledge.amount
      puts "Project #{@name}'s pledges: #{@pledges}"
    end

    def add_pledge(sample_pledge)
      @funding += sample_pledge.amount
    
      # puts "Project #{@name} received a #{sample_pledge.name} pledge worth #{sample_pledge.amount}."
    end
  
    # A
  
    def each_received_pledge
      @pledges.each do |name, amount|
        yield Pledge.new(name, amount)
      end
    end
  
  
    #--------------------------------------------
    # second way - second half. First half in fundrequest.rb
    #--------------------------------------------
  
    def self.from_csv(string)
      name, funding, goal = string.split(',')    
      new(name, Integer(funding), Integer(goal))
    end
  
    #--------------------------------------------
    #--------------------------------------------
  
  
    # def practice
  #     @pledges.each do |key, value|
  #       puts "$#{value} in #{key} pledges"
  #     end
  #   end

  end
end


if __FILE__ == $0
project4 = Project.new("aaa", 500, 1000)
project5 = Project.new("bbb", 750, 1500)
project4.rise
project5.rise
project4.drop
project5.drop  
project4.rise
project5.rise
puts project4
puts project5
puts project4.funding
puts project5.funding
end
